﻿using AspNetCoreApi.DbContexts;
using AspNetCoreApi.Models;
using AspNetCoreApi.Services;
using Microsoft.AspNetCore.Mvc;

namespace AspNetCoreApi.Controllers
{
    [ApiController]
    [Route("[controller]")]
    public class ProductController : ControllerBase
    {
        private readonly ILogger<ProductController> _logger;
        private readonly ProductService _service;

        public ProductController(ILogger<ProductController> logger, ProductService service)
        {
            _logger = logger;
            _service = service;
        }

        [HttpGet(Name = "GetProduct")]
        public IEnumerable<Product> Get()
        {
            return _service.GetProducts();
        }
    }
}
